"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class InterpretedGenome(ProtocolElement):
    """
    A interpreted genome for the rare disease program. This holds the list
    of candidate variants reported by an interpretation service
    together with all the relevant information that identify the case
    and how these conclusions were reached.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "interpretationRequestId",
        "interpretationRequestVersion",
        "interpretationService",
        "referenceDatabasesVersions",
        "softwareVersions",
        "versionControl",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import reports as reports_6_4_0

        return {
            "chromosomalRearrangements": reports_6_4_0.ChromosomalRearrangement,
            "karyotypes": reports_6_4_0.Karyotype,
            "shortTandemRepeats": reports_6_4_0.ShortTandemRepeat,
            "structuralVariants": reports_6_4_0.StructuralVariant,
            "uniparentalDisomies": reports_6_4_0.UniparentalDisomy,
            "variants": reports_6_4_0.SmallVariant,
            "versionControl": reports_6_4_0.ReportVersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import reports as reports_6_4_0

        return {
            "org.gel.models.report.avro.ChromosomalRearrangement": reports_6_4_0.ChromosomalRearrangement,
            "org.gel.models.report.avro.Karyotype": reports_6_4_0.Karyotype,
            "org.gel.models.report.avro.ShortTandemRepeat": reports_6_4_0.ShortTandemRepeat,
            "org.gel.models.report.avro.StructuralVariant": reports_6_4_0.StructuralVariant,
            "org.gel.models.report.avro.UniparentalDisomy": reports_6_4_0.UniparentalDisomy,
            "org.gel.models.report.avro.SmallVariant": reports_6_4_0.SmallVariant,
            "org.gel.models.report.avro.ReportVersionControl": reports_6_4_0.ReportVersionControl,
            "org.gel.models.report.avro.InterpretedGenome": reports_6_4_0.InterpretedGenome,
        }

    __slots__ = [
        "interpretationRequestId",
        "interpretationRequestVersion",
        "interpretationService",
        "referenceDatabasesVersions",
        "softwareVersions",
        "versionControl",
        "chromosomalRearrangements",
        "comments",
        "karyotypes",
        "reportUrl",
        "shortTandemRepeats",
        "structuralVariants",
        "uniparentalDisomies",
        "variants",
    ]

    def __init__(
        self,
        interpretationRequestId,
        interpretationRequestVersion,
        interpretationService,
        referenceDatabasesVersions,
        softwareVersions,
        versionControl,
        chromosomalRearrangements=None,
        comments=None,
        karyotypes=None,
        reportUrl=None,
        shortTandemRepeats=None,
        structuralVariants=None,
        uniparentalDisomies=None,
        variants=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_4_0.InterpretedGenome model.

        :param interpretationRequestId:
            Identifier for this interpretation request
        :type interpretationRequestId: str
        :param interpretationRequestVersion:
            Version for this interpretation request
        :type interpretationRequestVersion: int
        :param interpretationService:
            Name of the interpretation service
        :type interpretationService: str
        :param referenceDatabasesVersions:
            This map contains the versions of the different databases used in the
            process, being the database names the keys and the
            versions the values.
        :type referenceDatabasesVersions: dict[str, str]
        :param softwareVersions:
            This map contains the versions of the different software systems used
            in the process, being the software names the keys and the
            versions the values.
        :type softwareVersions: dict[str, str]
        :param versionControl:
            Model version number
        :type versionControl: ReportVersionControl
        :param chromosomalRearrangements:
            List of complex structural reported variants (chomosomal
            rearrangement)
        :type chromosomalRearrangements: None | list[ChromosomalRearrangement]
        :param comments:
            Comments about the report
        :type comments: None | list[str]
        :param karyotypes:
            List of inferred karyotypes across all the individuals in this report
        :type karyotypes: None | list[Karyotype]
        :param reportUrl:
            URL where the results can be accessed in the company's web interface
        :type reportUrl: None | str
        :param shortTandemRepeats:
            List of short tandem repeat variants
        :type shortTandemRepeats: None | list[ShortTandemRepeat]
        :param structuralVariants:
            List of simple structural reported variants (duplications, deletions,
            insertions, inversions, CNVs)
        :type structuralVariants: None | list[StructuralVariant]
        :param uniparentalDisomies:
            List of uniparental disomies across all the individuals in this report
        :type uniparentalDisomies: None | list[UniparentalDisomy]
        :param variants:
            List of small reported variants
        :type variants: None | list[SmallVariant]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.4.0"
